"use strict";

require("@babel/polyfill");

var _index = _interopRequireDefault(require("../index"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var SESSION = {
  token: 'abc123'
};
describe('SessionStore', function () {
  describe('when the session store has not yet been initialized', function () {
    describe('initialized', function () {
      it('should return false', function () {
        expect(_index["default"].initialized).toEqual(false);
      });
    });
  });
  describe('when session store has been initialized', function () {
    beforeEach(
    /*#__PURE__*/
    _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee() {
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return _index["default"].initialize();

            case 2:
              _context.next = 4;
              return _index["default"].deleteSession();

            case 4:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    })));
    describe('initialized', function () {
      it('should return true', function () {
        expect(_index["default"].initialized).toBe(true);
      });
    });
    describe('saveSession', function () {
      var session;
      beforeEach(
      /*#__PURE__*/
      _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2() {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return _index["default"].saveSession(SESSION);

              case 2:
                _context2.next = 4;
                return _index["default"].getSession();

              case 4:
                session = _context2.sent;

              case 5:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      })));
      it('should have saved the passed data', function () {
        expect(session).toStrictEqual(SESSION);
      });
    });
    describe('deleteSession', function () {
      var session;
      beforeEach(
      /*#__PURE__*/
      _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee3() {
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return _index["default"].saveSession(SESSION);

              case 2:
                _context3.next = 4;
                return _index["default"].deleteSession();

              case 4:
                _context3.next = 6;
                return _index["default"].getSession();

              case 6:
                session = _context3.sent;

              case 7:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3);
      })));
      it('should have the session as null', function () {
        expect(session).toBe(null);
      });
    });
    describe('hasSession', function () {
      describe('when the session has been already saved', function () {
        beforeEach(
        /*#__PURE__*/
        _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee4() {
          return regeneratorRuntime.wrap(function _callee4$(_context4) {
            while (1) {
              switch (_context4.prev = _context4.next) {
                case 0:
                  _context4.next = 2;
                  return _index["default"].saveSession(SESSION);

                case 2:
                case "end":
                  return _context4.stop();
              }
            }
          }, _callee4);
        })));
        it('should return true', function () {
          expect(_index["default"].hasSession).toBe(true);
        });
      });
      describe('when the session has not been saved', function () {
        it('should return false', function () {
          expect(_index["default"].hasSession).toBe(false);
        });
      });
    });
  });
});