"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _mobx = require("mobx");

var _storage = require("./storage");

var _constants = require("./constants");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Store = function Store() {
  var _this = this;

  _classCallCheck(this, Store);

  _defineProperty(this, "initialize",
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee() {
    var options,
        hasSession,
        _args = arguments;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            options = _args.length > 0 && _args[0] !== undefined ? _args[0] : {
              name: _constants.DEFAULT_INSTANCE_NAME
            };

            _storage.Storage.initialize(options);

            _context.next = 4;
            return _this.getSession();

          case 4:
            _context.t0 = _context.sent;
            hasSession = _context.t0 !== null;
            (0, _mobx.runInAction)(function () {
              _this.initialized = true;
              _this.hasSession = hasSession;
            });

          case 7:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  })));

  _defineProperty(this, "saveSession",
  /*#__PURE__*/
  function () {
    var _ref2 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee2(session) {
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return _storage.Storage.set(_constants.SESSION_KEY, session);

            case 2:
              (0, _mobx.runInAction)(function () {
                _this.hasSession = true;
              });

            case 3:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    return function (_x) {
      return _ref2.apply(this, arguments);
    };
  }());

  _defineProperty(this, "getSession", function () {
    return _storage.Storage.get(_constants.SESSION_KEY);
  });

  _defineProperty(this, "deleteSession", function () {
    _storage.Storage.remove(_constants.SESSION_KEY);

    (0, _mobx.runInAction)(function () {
      _this.hasSession = false;
    });
  });

  (0, _mobx.extendObservable)(this, {
    hasSession: false,
    initialized: false
  });
};

var _default = new Store();

exports["default"] = _default;